public class Aufgabe2 {

    /*
    Aufgabe:
        Methoden zur Manipulation eines zwei-dimensionalen Arrays, interpretiert
        als Matrix (mit Zeilen und Spalten).
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt.

    Punkte (maximal 20):
        10 Punkte für 'reconstruct',
        10 Punkte für 'undo'.
    */

    // Erzeugt aus 'columns' und 'height' ein Spielfeld für das "Vier-Gewinnt"-Spiel,
    // d.h ein rechteckiges Array mit einem bestimmten Spielzustand (siehe Beispiele unten).
    // In columns[i] stehen nur Einträge 1 oder 2. Diese stehen für die Spielsteine
    // in einer Spalte 'i' des Spielfelds in der Reihenfolge von oben nach unten.
    // Beachten Sie die Beispiele in der Methode 'main'.
    // Vorbedingungen:
    // columns != null,
    // columns.length > 0 und columns[i] != null für alle gültigen i, sowie
    // columns[i].length <= height
    public static int[][] reconstruct(int[][] columns, int height) {
        // TODO: implementieren Sie die Methode.

        if(columns==null||columns.length<=0){
            return null; //nicht definiert
        }

        for(int x =0;x<columns.length;x++){
            if(columns[x]==null||columns[x].length>height) return null;
        }


        int[][] ar = new int[height][columns.length];

        for(int i =0; i<columns.length;i++){

            for(int a = columns[i].length-1; a>=0; a--){

                for(int h =ar.length-1; h>=0;h--){

                    if(ar[h][i]==0){
                        ar[h][i]=columns[i][a];
                        break;
                    }
                }
            }

        }



        return ar; // TODO: entfernen Sie diese Zeile.

    }



    // Entfernt aus columns[i] den ersten Eintrag. Das
    // Array an der Stelle columns[i] ist danach um 1 kürzer.
    // Tut nichts, wenn columns[i].length = 0
    // Vorbedingung:
    // columns != null,
    // columns.length > 0 und columns[i] != null
    // i ist ein gültiger Index.
    public static void undo(int[][] columns, int i) {
        // TODO: implementieren Sie die Methode.
        if(columns.length<=0||columns[i]==null){
            return;
        }

        int [] ar = new int[columns[i].length-1];

        for(int a = 0; a<ar.length;a++){
            ar[a]=columns[i][a+1];
        }

        columns[i]=ar;

    }

    // Gibt das angegebene Array mit Tabulator als Trennzeichen aus.
    // Der Index erhöht sich von links nach rechts.
    // Vorbedingung: array != null
    // DIESE METHODE SOLL NICHT VERÄNDERT WERDEN.
    public static void printSimpleArray(int[] array) {
        for (int i = 0; i < array.length; i++) {
            System.out.print(array[i] + "\t");
        }
        System.out.println();

    }

    // Gibt das angegebene Array zeilenweise aus.
    // Der Zeilenindex erhöht sich von oben nach unten.
    // Der Spaltenindex erhöht sich von links nach rechts.
    // Vorbedingung: array != null und alle array[i] != null (0 <= i < array.length)
    // DIESE METHODE SOLL NICHT VERÄNDERT WERDEN.
    public static void printMultiArray(int[][] array) {
        for (int i = 0; i < array.length; i++) {
            for (int j = 0; j < array[i].length; j++) {
                System.out.print(array[i][j] + "\t");
            }
            System.out.println();
        }

    }

    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {
        int[][] columns = new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{},{}};
        printMultiArray(columns);
        // 2
        // 2   1   2   1
        // 2   1   1
        // 1   1
        // 2   2
        //
        //

        printMultiArray(reconstruct(columns,6));
        // 0   0   0   0   0   0   0
        // 0   0   0   0   0   0   0
        // 0   2   0   0   0   0   0
        // 0   1   2   0   0   0   0
        // 0   2   1   1   2   0   0
        // 2   1   1   1   2   0   0
        
        undo(columns,1);
        printMultiArray(columns);
        // 2
        // 1   2   1
        // 2   1   1
        // 1   1
        // 2   2
        //
        //

        printMultiArray(reconstruct(columns,6));
        // 0   0   0   0   0   0   0
        // 0   0   0   0   0   0   0
        // 0   0   0   0   0   0   0
        // 0   1   2   0   0   0   0
        // 0   2   1   1   2   0   0
        // 2   1   1   1   2   0   0

    }

}

