import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Test
    public void testReconstruct1Times1() throws Exception {
        int[][] expectedResult = new int[][] {
                {2}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{2}},1);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReconstruct3Times1() throws Exception {
        int[][] expectedResult = new int[][] {
                {0},{0},{2}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{2}},3);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReconstruct1Times2() throws Exception {
        int[][] expectedResult = new int[][] {
                {1,1}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{1},{1}},1);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReconstruct1Times2Empty() throws Exception {
        int[][] expectedResult = new int[][] {
                {0,0}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{},{}},1);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReconstruct5Times6() throws Exception {
        int[][] expectedResult = new int[][] {
                {0,0,0,0,0,0},
                {0,2,0,0,0,0},
                {0,1,2,0,0,0},
                {0,2,1,1,2,0},
                {2,1,1,1,2,0}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{}},5);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReconstruct6Times7() throws Exception {
        int[][] expectedResult = new int[][] {
                {0,0,0,0,0,0,0},
                {0,0,0,0,0,0,0},
                {0,2,0,0,0,0,0},
                {0,1,2,0,0,0,0},
                {0,2,1,1,2,0,0},
                {2,1,1,1,2,0,0}};
        int[][] result = Aufgabe2.reconstruct(new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{},{}},6);
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testUndo() throws Exception {
        int[][] expectedResult = new int[][] {{2},{1,2,1},{2,1,1},{1,1},{2,2},{}};
        int[][] array = new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{}};
        Aufgabe2.undo(array,1);
        Assert.assertArrayEquals(expectedResult, array);
    }

    @Test
    public void testUndoEmptyColumn() throws Exception {
        int[][] expectedResult = new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{},{}};
        int[][] array = new int[][] {{2},{2,1,2,1},{2,1,1},{1,1},{2,2},{},{}};
        Aufgabe2.undo(array,5);
        Assert.assertArrayEquals(expectedResult, array);
    }

}