import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;

public class Aufgabe3Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    // liefert absteigend alle Teiler von n, die im Intervall i bis n-1 liegen,
    // durch ',' getrennt in einem String.
    // Vorbedingung: n > 0 und 1 < i < n
    public static String dividers(int n, int i) {
        String s = "";
        do {
            if (n%i == 0) {
                if (!s.equals("")) {
                    s = "," + s;
                }
                s = i + s;
            }
            i++;
        } while (i < n);
        return s;
    }

    // Vorbedingung: k != 0
    public static int f(int n, int k) {
        return n < 0 ? f(-2*n,k) : n/(2*k);
    }

    @Test
    public void testDividersWithoutSeparator() throws Exception {
        for (int n = 2; n < 100; n++) {
            for (int i = 2; i < n; i++) {
                Assert.assertThat(Aufgabe3.dividers(n, i).replaceAll(",", ""),
                        is(Aufgabe3Test.dividers(n, i).replaceAll(",", "")));
            }
        }
    }

    @Test
    public void testDividersFull() throws Exception {
        for (int n = 2; n < 100; n++) {
            for (int i = 2; i < n; i++) {
                Assert.assertThat(Aufgabe3.dividers(n, i),
                        is(Aufgabe3Test.dividers(n, i)));
            }
        }
    }

    @Test
    public void testF() throws Exception {
        for(int n = -10; n <= 10; n++) {
            for(int k = -10; k <= 10; k++) {
                if (k == 0) continue;
                Assert.assertThat(Aufgabe3.f(n,k), is(Aufgabe3Test.f(n,k)));
            }
        }

    }

    @Test
    public void testPrintSimpleArray() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 1,3);
        assertEquals("11\t10\t2", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayWithoutSeparator() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 0,3);
        assertEquals("111021", log.getLog().trim().replaceAll("\\s",""));
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayStart() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 0,3);
        assertEquals("11\t10\t2\t1", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayEnd() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 2,4);
        assertEquals("12\t11\t10", log.getLog().trim());
        log.clear();
    }

}